#include <iostream>
#include <vector>
#include <math.h>
#include <iomanip>
#include "moves.hpp"

using namespace std;


/* Initalize output object based on the number of municipalities */

void initialize_results(const input &data, output &results);


void update_similarity(const vector<cluster> &Clusters,
		       const vector<int> &labels, output &results);

/* Store sampled parameters and similarity of municipalities */

void store_samples(const vector<cluster> &Clusters, const hyperparam &param,
		   const vector<int> &labels, output &results);


/* Write posterior mean of sampled parameters and cluster allocation
   to output files "Parameters.txt" and "Similrity.txt" */

void write_to_file(const output &results, const input &data,
		   const RJMCMC &Setup, char *argv[]);
