#include <iostream>
#include <vector>
#include <math.h>
#include "classes.hpp"

using namespace std;


/* Log-density of a beta-binomial distribution */

double log_dBetaBinom(const int &k, const int &n,
		      const double &a, const double &b);


/* Log-density of a Gamma distribution */

double log_dGamma(const double &x, const double &a, const double &b);


/* Log-density of a Normal distribution */

double log_dNormal(const double &x, const double &m, const double &v);


/* Log-density of a Log-normal distribution */

double log_dlogNormal(const double &x, const double &m, const double &v);


/* Log-likelihood function for generalized Pareto distribution */

double GPD_llike(const vector<double> &pot, const double &max_pot,
		 const double &sigma, const double &xi);


/* Gradient of GPD log-likelihood function */
  
vector<double> GPD_llike_grad(const vector<double> &pot,
			      const double &sigma, const double &xi);
  
  
/* Derive log-likelihood GPD for data with curvature adjustment */

double GPD_llike_curv(const vector<double> &obs, const cluster &Cluster,
		      const double &max_obs);


/* Derive the log-likelihood of Chi measure across the whole data set */

double Chi_llike(const vector<cluster> &Clusters, const input &data,
		 const vector<int> &labels, const hyperparam &param);


/* Derive the log-likelihood of Chi measure across one cluster */

double Chi_llike_Cluster(const cluster &Cluster, const input &data,
			 const vector<int> &labels, const hyperparam &param);
