#include "estimate_eta.hpp"

using namespace std;

/* Read settings for the RJMCMC algorithm from the file "Setup.txt" */

void read_Setup( RJMCMC &Setup, int argc, char *argv[] );


/* Check probabilities are positive and scale them to add up to 1 */

void validate_proposal_prob( vector<double> &proposal_prob );


/* Read observed peaks-over threshold and data for extremal dependence */

void read_data( input &data, const RJMCMC &Setup, char* argv[] );


/* Read observations for all sites from "PeaksOverThreshold.txt" */

void read_peaksfile( input &data, const RJMCMC &Setup, char* argv[] );


/* Read neighbourhood structure/distances and Chi measures */

void read_neighbours( input &data, char* argv[] );


/* Derive pairwise distances between sites */

void derive_distances( input &data, char* argv[] );


/* Sample initial cluster centers and allocate cluster labels */

void init_clusters(vector<cluster> &Clusters,
		   vector<int> &no_centers, vector<int> &labels,
		   input &data, mt19937 &RNG, hyperparam &param);
