library(mcclust)
library(mcclust.ext)
library(coda)

score_clustering <- matrix(0, 100, 3)

for(i in 1:100){

  setwd( paste("Run",i,sep="") )
  
  obs <- read.table("Number of clusters and hyperparameters.txt", header = T)
  
  ## Plot estimated spatial cluster structure
  sites      <- c( 1:41, 79, 80, 81, 82, 84, 92:94, 100:102, 105:107 )
  similarity <- as.matrix( read.table("Similarity.txt") )
  labels_fit <- minVI(similarity)$cl
  
  ## Number of clusters
  score_clustering[i,1] <- max(labels_fit) 
  ## Posterior median
  score_clustering[i,2] <- quantile( obs$Number_of_clusters, 0.5 )
  ## Posterior probability of J=1
  score_clustering[i,3] <- 
    sum( as.numeric(obs$Number_of_clusters) == 1 ) / length(obs$Number_of_clusters)
  
  setwd("../")
  
}

## Check how ofyen clustering is correct
print( "How often is the cluster structure recovered:")
print( sum(score_clustering[,1]==1) )
## Average of the posterior median number of clusters
print( mean(score_clustering[,2]))